set define off
declare
  im_id         numeric(16);
  im_name       varchar(256) := 'AGC';

  fc_id         numeric(16);
  fc_name       varchar(256) := 'system';
  
  fevt_id       numeric(16);
  fevt_name     varchar(256) := 'IN';
  
  f_id          numeric(16);
  f_name        varchar(256) := 'USER_BEFORE';
  
  fr_id         numeric(16);
  fr_name       varchar(256) := 'Update User Type';
  fr_desc       varchar(512) := '[ V1.1 - 2017-03-13] - UPDATE user type if it changes in USER_ERC';
  
  fr_lob        clob := 'rule "Update User Type"
'||'when
'||'    event : EventInBean(  )  
'||'    userErcBean : UserErcBean(  )
'||'then
'||'logger.debug("USERS input transformation, event:" + event);
'||'EventInBean eventin = (EventInBean) event;
'||'final long MODIFY = 2;
'||'
'||'long currentOperation = eventin.getOperation();
'||'String userType = (String) userErcBean.getAttribute("USER_TYPE");
'||'Long ercTableId = (Long) userErcBean.getAttribute("ID");
'||'String userid = (String) userErcBean.getAttribute("PM_CODE");
'||'if (userid==null) {
'||'  return;
'||'}
'||'
'||'if (currentOperation == MODIFY) {
'||'  UserBean userBean = UtilAction.findUserByCode(sql, userid);
'||'  if (userBean != null) {
'||'    String currentPersonType = userBean.getPersontype_name();
'||'    if(currentPersonType!=null && !currentPersonType.isEmpty()) {
'||'      if (!currentPersonType.equalsIgnoreCase(userType)) {
'||'        UserTypeBean userTypeBean = new UserTypeBean();
'||'        userTypeBean.setName(userType);
'||'        BeanList<UserTypeBean> bl = UserTypeAction.findUserType(sql, userTypeBean, new Paging(5));
'||'        if(!bl.isEmpty()) {
'||'          userTypeBean= bl.get(0);
'||'          userBean.setPersontype_id(userTypeBean.getId());
'||'          UserAction.modifyUser(sql, userBean, null);
'||'        }
'||'      }
'||'    }
'||'  }
'||'}
'||'
'||'end
'||'';

  counter       numeric(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );

    update flow_rule set description = fr_desc where id = fr_id;

    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
