declare
  sk_id         numeric(16);
  sk_name       varchar(256) := 'Internal';
  
  sk_prop_id    numeric(16);
  sk_prop_name  varchar(256) := 'org.quartz.jobStore.driverDelegateClass';
  sk_prop_value varchar(256) := 'org.quartz.impl.jdbcjobstore.DB2v8Delegate';

  counter       numeric(16);
begin
  select count(1) into counter from scheduler t where lower ( t.name ) = lower ( sk_name );
  if ( counter = 1) then
    select t.id into sk_id from scheduler t where lower ( t.name ) = lower ( sk_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO SCHEDULER FOUND!');
  end if;

  select count(1) into counter from scheduler_prop t where t.scheduler = sk_id and lower ( t.name ) = lower ( sk_prop_name );
  if ( counter = 0 ) then
    select max(id)+1 into sk_prop_id from scheduler_prop; 

    insert into scheduler_prop ( id, scheduler, name, value )
    values ( sk_prop_id, sk_id, sk_prop_name, sk_prop_value );
  else 
    update scheduler_prop set value = sk_prop_value where scheduler = sk_id and lower ( name ) = lower ( sk_prop_name );
  end if;
end;
/
commit;