set define off
declare
  im_id         number(16);
  im_name       varchar2(256) := 'AGC';

  fc_id         number(16);
  fc_name       varchar2(256) := 'system';
  
  fevt_id       number(16);
  fevt_name     varchar2(256) := 'TARGET';
  
  f_id          number(16);
  f_name        varchar2(256) := 'PERMISSION_ADD';

  f_lob         clob := 'package tADD_FUN;
'||'
'||'import com.engiweb.logger.impl.Log4JImpl;
'||'import com.engiweb.pm.entity.BeanList;
'||'import com.engiweb.profilemanager.backend.business.direct.ExternalRoleDirect;
'||'import com.engiweb.profilemanager.backend.dao.db.SQLH;
'||'import com.engiweb.profilemanager.common.bean.AccountBean;
'||'import com.engiweb.profilemanager.common.bean.Block;
'||'import com.engiweb.profilemanager.common.bean.OrgUnitBean;
'||'import com.engiweb.profilemanager.common.bean.UserBean;
'||'import com.engiweb.profilemanager.common.bean.entitlement.EntitlementBean;
'||'import com.engiweb.profilemanager.common.bean.FunctionalityTypeBean;
'||'import com.engiweb.profilemanager.common.bean.event.EntStateBean;
'||'import com.engiweb.profilemanager.common.bean.event.EventTargetBean;
'||'import com.engiweb.profilemanager.common.bean.rule.SyncStateBean;
'||'import com.engiweb.profilemanager.common.ruleengine.action.EntitlementAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.OrgUnitAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.UserAction;
'||'import com.engiweb.profilemanager.common.ruleengine.action.ApplicationAction;
'||'import com.engiweb.toolkit.common.DBMSException;
'||'
'||'global com.engiweb.profilemanager.backend.dao.db.SQLH sql;
'||'global com.engiweb.logger.impl.Log4JImpl logger;
'||'
'||'
'||'
';
 
  fr_id         number(16);
  fr_name       varchar2(256) := 'Create permission if it doesn''t exist';
  fr_desc       varchar2(512) := '[ V1.2 - 2017-06-20 ]'; 
  
  fr_lob        clob := 'rule "Create permission if it doesn''t exist"
'||'	 when
'||'		event : EventTargetBean(  )
'||'		syncBean : SyncStateBean(  )
'||'
'||'	 then
'||'  // [ V1.1 - 2014-05-26 ]
'||'
'||'  if (event.getLevel() == EventTargetBean.PROFILE_NOT_FOUND) {
'||'
'||'    // Create and publish the permission ...
'||'
'||'    EntitlementBean entBean = syncBean.getProfile();
'||'    // Not Administrative Role
'||'    entBean.setAdministrative(0L);
'||'
'||'    if (entBean.getFunctionalityType_name() == null) {
'||'      // If Type is not setted, set equals to the application name
'||'      entBean.setFunctionalityType_name(entBean.getApplication_name() + "Type");
'||'    }
'||'
'||'    if (event.getAttr5()!=null ) {
'||'      entBean.setDescription(event.getAttr5());
'||'    }
'||'
'||'    // Create permission type if does it not exist
'||'    FunctionalityTypeBean ft = new FunctionalityTypeBean();
'||'    ft.setApplication_id(entBean.getApplication_id());
'||'    ft.setName(entBean.getFunctionalityType_name());
'||'
'||'    BeanList bl = ApplicationAction.findFunctionalityType(sql, ft);
'||'    if (bl.size() == 0) {
'||'      ApplicationAction.addFunctionalityType(sql, ft);
'||'    }
'||'
'||'    // Create the entitlement
'||'    try {
'||'      ExternalRoleDirect extDirect = new ExternalRoleDirect();
'||'      entBean  = extDirect.insertExternalRole(entBean, sql);
'||'      //entBean = EntitlementAction.insertEntitlement(sql, entBean, true);
'||'    } catch (DBMSException e) {
'||'      if (e.getErrorCode() == DBMSException.OBJECT_NOT_FOUND) {
'||'        throw new Exception("Error creating permission");
'||'      } else {
'||'        throw e;
'||'      }
'||'    }
'||'
'||'    logger.debug("Permission " + entBean.getName() + " created, application " + entBean.getApplication_name());
'||'
'||'    // Update the current event object
'||'    event.setLevel(EventTargetBean.OU_PROFILE_NOT_FOUND);
'||'    syncBean.setProfile(entBean);
'||'
'||'  }
'||'end
'||'
';

  counter       number(16);
begin
  select count(1) into counter from ideas_module t where lower ( t.code ) = lower ( im_name );
  if ( counter = 1 ) then
    select t.id into im_id from ideas_module t where lower ( t.code ) = lower ( im_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO IDEAS MODULE FOUND' );
  end if;

  select count(1) into counter from flow_context t where lower ( t.name ) = lower ( fc_name );
  if ( counter = 1 ) then
    select t.id into fc_id from flow_context t where lower ( t.name ) = lower ( fc_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW CONTEXT FOUND' );
  end if;

  select count(1) into counter from flow_event_type t
  where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  if ( counter = 1 ) then
    select t.id into fevt_id from flow_event_type t
    where t.flow_context = fc_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fevt_name );
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW EVENT TYPE FOUND' );
  end if;
  
  select count(1) into counter from flow t
  where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name ); 
  if ( counter = 1 ) then
    select t.id into f_id from flow t
    where t.ideas_module = im_id and t.flow_event_type = fevt_id and lower ( t.name ) = lower ( f_name );
	
	update flow set flow_lob = f_lob where id = f_id;
  else
    RAISE_APPLICATION_ERROR ( -20200, 'NO FLOW FOUND' );
  end if;

  select count(1) into counter from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );
  if ( counter = 0 ) then
    select flow_rule_seq.nextval into fr_id from dual;
    insert into flow_rule ( id, flow, name, description, rule_lob, ideas_module )
    values ( fr_id, f_id, fr_name, fr_desc, fr_lob, im_id );
  else
    select t.id into fr_id from flow_rule t where t.flow = f_id and t.ideas_module = im_id and lower ( t.name ) = lower ( fr_name );

    update flow_rule set description = fr_desc where id = fr_id;

    update flow_rule set rule_lob = fr_lob where id = fr_id;
  end if;

end;
/
commit;
set define on
